# $Id: ITO.spec,v 2.73 2014/02/04 00:29:30 ksb Exp $
# $KeyFile: ${echo:-echo} Makefile
# $Level3: ${echo:-echo} msrc_base
#  msrc-path symbolic-version [local-path]
# $List2s: %|/# /%J cat %j
# ${MSRC_ROOT}/local/bin/mkcmd Eight
# ${MSRC_ROOT}/local/lib/mkcmd Eight
# ${MSRC_ROOT}/local/bin/explode Six
# ${MSRC_ROOT}/local/lib/explode Six
# ${MSRC_ROOT}/local/bin/ptbw One
# ${MSRC_ROOT}/local/bin/xclate Two
# ${MSRC_ROOT}/local/bin/xapply Three
# ${MSRC_ROOT}/local/sbin/hxmd One
# ${MSRC_ROOT}/local/lib/hxmd One
# ${MSRC_ROOT}/local/sbin/msrc One
# ${MSRC_ROOT}/local/bin/wrapw One
# ${MSRC_ROOT}/local/css One
# ${MSRC_ROOT}/local/cgi-bin/manpage.cgi One
# ${MSRC_ROOT}/Admin/master Four
# ${MSRC_ROOT}/Pkgs/msrc_base Two
# (co -p -rZero ${MSRC_ROOT}/local/lib/op/remote/level2s.cf.host >Pkgs/msrc_base/level2s.cf.host)
# (sleep 1)
# ${MSRC_ROOT}/local/sbin/mmsrc One
# (cd local/sbin/mmsrc && make restart __msrc && chmod u+w mmsrc.[ch])
# $List2s: %j%^

%define _local_prefix		/usr/local
%define _local_bindir		%{_local_prefix}/bin
%define _local_sbindir		%{_local_prefix}/sbin
%define _local_libdir		%{_local_prefix}/lib
%define _local_mandir		%{_local_prefix}/man

# for signing of packages
#%_signature gpg
#%_gpg_name FIXME@example.org

# %dist should be defined on the target but in case it isn't we can guess one
%define distguess %(cat /etc/{redhat,fedora,suse,ubuntu}-release | sed -e 's/Fedora Core/fc@/; s/Fedora/f@/; s/Red Hat[^0-9]*\(Enterprise|Server\)*[^0-9]*/rhel@/; s/Red Hat[^0-9]*/rh/; s/.*Suse[^0-9]*/se@/; s/Ubuntu[^0-9]*/ubuntu@/; s/@[^0-9]*//;s/\([0-9][0-9]*\)[^0-9][^0-9]*\([0-9][0-9]*\)/\1_\2/; s/[^0-9]*$//')
%{!?dist:%define dist .%{distguess}}

# Do not generate debugging packages by default - older versions of rpmbuild
# (like RehHat 6.2) choke on the line with the percent in the macro name:
# We need a sed spell on RH6.x to "s/\(^.define \)%d/\1d/", Sigh. -- ksb
%define debug_package %{nil}

Name:		msrc_base
Version:	2.44
Release:	3%{?dist}
Vendor:		NPCGuild.org
Summary:	NPC Guild technology base for all products
Group:		Utilities
License:	BSD
URL:		http://msrc.npcguild.org/
Source:		http://carrera.databits.net/~ksb/dl/2013/%{name}-%{version}.tgz
BuildRequires:	gcc m4 /bin/bash /bin/ksh flex bison make /usr/bin/install
BuildRoot:	/var/tmp/%{name}-%{version}
Autoreq:	0
Requires:	gcc bzip2 /bin/ksh m4 rdist /usr/bin/ssh make
Provides:	mkcmd mkcmd_lib explode explode_lib ptbw xclate xapply wrapw hxmd msrc mmsrc msrc_base

%description
This is the core technology which provided wrappers, master source,
parallel process management, collated output diversion, the basis
of host-based configuration management and makes all your dreams come
true.  It is a must-have for all sites with more than ten computers.
Learn to use it and you won't ever be sorry.  I promise.

%prep
%setup
%build
%install
mkdir -p %{buildroot}%{_local_bindir} %{buildroot}%{_local_sbindir}
mkdir -p %{buildroot}%{_local_libdir}/mkcmd
mkdir -p %{buildroot}%{_local_libdir}/explode %{buildroot}%{_local_libdir}/hxmd
mkdir -p %{buildroot}%{_local_mandir}/man1 %{buildroot}%{_local_mandir}/man5
mkdir -p %{buildroot}%{_local_mandir}/man8
HOSTTYPE=`uname -s | tr '[:lower:]' '[:upper:]'`
if [ -r /etc/redhat-release ] ; then
	HOSTOS=$(printf '%d%0.2d00' $(sed 's/[^0-9]*\([0-9][0-9]*\)\(.\([0-9][0-9]*\)\)*.*/\1 \3/' /etc/redhat-release ))
else
	HOSTOS="00"
fi
PATH=%{buildroot}%{_local_sbindir}:%{buildroot}%{_local_bindir}:$PATH
MKCMD="-I .:%{buildroot}%{_local_libdir}/mkcmd/type:%{buildroot}%{_local_libdir}/mkcmd"
EXPLODE="-I .:%{buildroot}%{_local_libdir}/explode"
HXMD_LIB=.:%{buildroot}%{_local_libdir}/hxmd${HXMD_LIB+":$HXMD_LIB"}
export PATH MKCMD EXPLODE HOSTOS HOSTTYPE HXMD_LIB

# Ignore the other payloads, just get the code for the RPM build a subspace
# for the platform mmsrc make to work under, parallel to our source dirs:
F=`mktemp -d /tmp/bmHMXXXXXX`
mkdir -p $F/bin $F/sbin $F/lib
mkdir -p $F/lib/mkcmd $F/lib/explode $F/lib/hxmd

# The install recipes depend on my install here, so use the boot recipe. --ksb
(
cd local/sbin/mmsrc
make clean boot
install -m 755 mmsrc %{buildroot}%{_local_sbindir}/mmsrc
)
PATH=$PATH:%{buildroot}%{_local_sbindir}:%{buildroot}%{_local_bindir}

# Now mmsrc is in our path -- much better.  Use it to boot the others:
# Set HOSTOS in auto.cf, and build a more complete hxmd lib for that first.
# The hard one, get auto.cf+mmsrc going, then put it in place.
# Also remove the HXMD_FROM build root prefix with perl.
(
make auto.cf
W=`pwd`
cd local/lib/hxmd &&
mmsrc -y INTO=$F/$t -C$W/auto.cf -DHOST=localhost -DHOSTTYPE=$HOSTTYPE -DHOSTOS=$HOSTOS -- make DESTDIR=%{buildroot} TOP=%{_local_prefix} boot &&
perl -pi -e 's@%{buildroot}@@' %{buildroot}%{_local_libdir}/hxmd/auto.cf
)

(
cd local
for t in lib/mkcmd lib/explode bin/mkcmd bin/explode \
	bin/ptbw bin/xclate bin/xapply bin/wrapw sbin/msrc sbin/hxmd sbin/msrc
do
	(cd $t && mmsrc -y INTO=$F/$t -C%{buildroot}%{_local_libdir}/hxmd/auto.cf -DHOST=localhost -DHOSTTYPE=$HOSTTYPE -DHOSTOS=$HOSTOS -- make DESTDIR=%{buildroot} TOP=%{_local_prefix} boot )
done
)

# If we had mk we'd use "make mkcat" above, in the install_base package we do.
# This assumes that the mk markup in the page follows ckman-style.
for page in `find . -name \*.man -print`
do
	Wp=`sed -ne 's!^.*[$]Install:.* cp .*man[1-9]/\([^/]*\)[.]\([1-9]\)!man\2/\1.\2!p'  <$page | head -1`
	if [ -n "$Wp" ] ; then
		install -c -m 644 $page %{buildroot}%{_local_mandir}/$Wp
	fi
done

rm -rf $F
find %{buildroot} -depth -type d -name OLD -exec rm -rf {} \;

%clean
# Do not conflict with the next user of the fixed-path build directory
[ / != "%{buildroot}" ] && rm -rf "%{buildroot}"

%pre
grep "^source:" /etc/group >/dev/null || groupadd %{?sourcegid:-g %{sourcegid}} source
grep "^source:" /etc/passwd >/dev/null || useradd %{?sourceuid:-u %{sourceuid}} -g source -d /usr/src source

%files
%defattr(-,root,root)
%{_local_sbindir}/mmsrc
%{_local_sbindir}/msrc
%{_local_sbindir}/hxmd
%{_local_bindir}/wrapw
%{_local_bindir}/xapply
%{_local_bindir}/xclate
%{_local_bindir}/ptbw
%{_local_bindir}/explode
%{_local_bindir}/mkcmd
%{_local_libdir}/mkcmd
%{_local_libdir}/explode
%config %{_local_libdir}/hxmd
%defattr(644,root,root)
%doc %{_local_mandir}/man1/*
%doc %{_local_mandir}/man5/*
%doc %{_local_mandir}/man8/*

%changelog
* Sat Feb  1 2014 KS Braunsdorf ksb@npcguild.org 2.44.3
- fixed errors in my spec template
- updated the rpmboot documentation and recipe
- use the macros more, allow /usr/local to change here
- do not hard-code the manual page names anymore
* Thu Jan 30 2014 KS Braunsdorf ksb@npcguild.org 2.44
- updated some manual pages for ckman font markup and .nf/.fi balance
- ptbw number of default processes uses POSIX on openbsd now.
- hxmd/msrc/mmsrc added defining file as HXMD_FROM then used it in auto.cf.host
- fixed a bug in the sendfile code for hxmd/msrc
- some small HTML updates, including error.html which is much better
- rpmboot and relocate are included here now, rather than getting lost
* Sun Oct 27 2013 KS Braunsdorf ksb@npcguild.org 2.43
- better ENTRY_LOGIN hook from Abby Braunsdorf in sbin/msrc/msrc.html
- lots of cleanup in HTML and manual pages
- added HXMD_FROM to hxmd, defines the config file that first defined a HOST
- upgrade auto.cf.host to include HXMD_FROM, MY_CLASS, MY_SERVICE as a demo
- renamed manpage.cgi's directory to manpage.cgi for better consistency
* Wed Aug 17 2013 KS Braunsdorf ksb@npcguild.org 2.42
- recipes converted to 2012 packages
* Wed Aug 10 2013 KS Braunsdorf ksb@npcguild.org 2.41
- html cleanup
* Sun Jan  6 2013 KS Braunsdorf ksb@npcguild.org 2.40
- spelling and grammer fixes in HTML files
- updated this spec file to pass rpmlint, thanks Chris Kolosiwsky for the poke
- updated diversion API and wrapw to make opal work as designed
- total package size is up about 30% due to adding the template recipe dir
- added the Admin/master templates directory (see above)
- added support for moving the TOP macro from /usr/local to something else
- BIN, SBIN, ETC, LIB, LIBEXEC, DOC all match their usage (overrides work now)
- added support for moving $TOP in manaul page markup as well
- moved css to local/css so the source is not the target install directory
- the code.html and code.css got an upgrade class="user", "group" added
- DARWIN is a complete port now, not a FREEBSD clone
- mkcmd got a few fixes, added a prototype of parameter exclusion (8.19)
- -e will now deletes and environment variable (-e !FOO) for xapply, xclate
- xapply (3.72) added -F script which excludes the cmd positional, %c %fc
-  interpreter "#!/usr/bin/env -S xapply -F" to load scripts under xapply
-  maybe later make hxmd -F0 use xapply -F
- wrapw is now a first-class member of this package
- a huge effort to make manual pages much better in style and SEE ALSOs.
-  .TH no longer have the "L" in the section header (that was a mistake)
-  .hlm 0 in SEE ALSO section (and SEE ALSO is in quotes now, always)
-  the leading dash on some options was not always bold
- gnumake.m4 msrc template now allows some additional overrides:
-  SITE_TOP, SITE_SHAREDSTATEDIR, SITE_LOCALSTATEDIR,
-  which are used to build DEFAULTCONFIGUREOPTIONS, or define that explicitly
-  targets.m4 is now quoted for the sinclude,
- added some missing id="" in HTML docs, mentioned ckman need to release it
* Mon Nov 12 2012 KS Braunsdorf ksb@npcguild.org 2.38
- moved jacket.m to api_jacket.m (for op jacket/helmet interface)
- copied hxmd modules to mkcmd's api directory
- added better support for DARWIN 10.5 (100500) and above (MacOS)
- mkcmd's errno handler is better, I think, for older systems
- fixed xapply -P to actually default to $PARALLEL again
- document conversion to xapply from find/dsh with some clues
- xclate -e !var removes the environment entry for $var, -e var=value too.
- ptbw: publish util_nproc* to mkcmd
- hxmd better error traps for unsupported operators
- more information in many -V outputs
- added some missing m4 quotes in platform recipe files, more std use of $O/$Q
- added support for level3s (which is still not complete)
- added error.html (which is also not complete)
- util_fsearch.m API changed a little, not literal text, but a string now
- more HTML fixes, that never ends (man page links, and added explode.html)
- (proof readers, Nathan Dye, Greg Rivers, Jim White and others -- thanks!)
- lots of spelling fixes in C strings, and nroff markup fixes in manual pages
- fixed more old email addresses
- used more ANSI C prototypes.  Next time I'll convert the rest.
* Thu May  3 2012 KS Braunsdorf ksb@npcguild.org 2.37
- small diff output: mostly bug fixes
- xclate: removed explict include of <sys/syslimits.h> which we not portable
- hxmd: -h was broken by -c code refactor, html some more details added
- spelling and format in html and manual pages (Pkg/msrc.html)
- added parallel.html in xapply document chain to help sell hxmd and msrc
* Tue Apr 17 2012 KS Braunsdorf ksb@npcguild.org 2.36
- 5,300 line diff: normalized stderr memory allocation error messages
- added top-level HTML pages to this package, fixed other HTML markup errors
- nested code markup, wrong code-class (sh/attr/make/opt), added id anchors.
- manpage.cgi major updates to fix hypenation and other nits
- s/What you need to know to understand/To understand/g
- added ptwb -z to allow NUL terminated tokens (balances xapply %t+)
- some minor lint fixes, didn't change cast of (const char *) to (char *)
- added reset logic to some statefull functions, added missing parameter decls
- fixed colon mode for ptbw client in one case not to fork an extra process
- added the `kill -USR1 %p' break to xapply, xclate; and code 3000 in hxmd
- make %t+ shit off the token (consume it) so "%t+;%t+;%t+" is really useful
- make -A/-R/-J work for hxmd to allow ptbw/gtfw access, ${1},${2} access works
- in INIT_CMD/PRE_CMD/POST_CMD ${6} is the first -A positional, ${7} the 2nd
- xclate protocol bump to 0.9, more fd passing allowed (for xapply USR1 support)
- xclate gets -P mode for passing short-circuit exit lists to -N output
- util_cache.m can handle -z options now (viz. for ptbw -z) line cnt => char cnt
- hxmd -a works almost like you'd expect, don't use ' ' as the magic character
- hxmd allows #comments in the USR1 stream for leverage later, so xids !~ m/^#/
- dmz.sh allows -C:other.cf to imply `basename`.cf:other.cf now (-Z/-X too)
- locking INTO=. in msrc/mmsrc works to find remote $HOME, better explain +++/.
- more HTML references to mpull and msrcmux to help you find those later.
* Tue Feb 28 2012 KS Braunsdorf ksb@npcguild.org 2.35
- made jackets work in op for many more cases, added
- added the make-msrc.sh script to help you make a clone of mine.
- xapply %Q, %W added and -H, fixed bug in nested %+ markup
- Allow INTO=. in msrc to force remote to be ~login (this is not safe)
- mkcmd didn't output the correct manual template for some options
- updated the hpux package pre-req list
- really updated cgi-bin/manpage.cgi: it works far better, local sections work
- the reference thing(1l) changes the MANPATH
- the THs are just 1 (not 1L) and the extra1 is LOCAL extra2 may spec alt name
- update nealy every manual page for format and some content.
- fixed a lot of see also links, so manpage.cgi works with them (.hlm 0)
- fixed up a lot of HTML docs for format and content
- more id=thing anchors for section/header refs
- fit HTML pages to standard browser window better (less left/right scrolling)
- added -e to the HTML options summary
- fixes to mkcmd's lib type "mode" and other nits, jacket.m missing Id markup
* Thu Oct 27 2011 KS Braunsdorf ksb@npcguild.org 2.34-3
- added the script (make-msrc.sh) to build "msrc" from "dl"
* Tue Oct 25 2011 KS Braunsdorf ksb@npcguild.org 2.34-2
- mmsrc passed MMSRC_PASS down because I removed the unsetenv by mistake
* Wed Oct 19 2011 KS Braunsdorf ksb@npcguild.org 2.34-1
- I forgot to add wrapw to the RPM build (in this file) of all places
* Wed Oct 19 2011 KS Braunsdorf
- added the complete wrapw directory rather than a shim
- made msync work with packages vi mk markup in the recipe
- lots of manual page markup fixes, and some HTML tidy fixes
- some tiny mkcmd bugs only I ever cared about (now less lint in output files)
- missing -o - option in some explode recipe usages, how did that work?
- more id=tag markup in most HTML pages for external links
- xapply now accepts -0 to be compatible with apply(1) (check --2 Easter Egg)
- fixed a but in mkutemp(3L) which made it always fail (lib/explode)
- made pipering work for more clients (Tee now uses it)
- scandir got a test driver, but it is mostly lame.
- unctime compiles on Linux again.
- I had used "expr" rather than "eval" in some m4 markup because I'm a BSD guy
- implemented double-dot in hxmd's configuration file for "use outer value"
- updated jacket.m for the new op in install_base
- msrc/mmsrc -m "msrc:lean" can have multple words in the targets now
- some spelling/word fixes (as usual for my work).
* Thu Apr 14 2011 KS Braunsdorf ksb@npcguild.org 2.33
- fixed a bug in hostdb.m (output junk error messages for extra config columns)
- updated hxmd's manual page
- msync markup and target for the much better msync interface
- with the new msync "sub_sync=sub_sync msync" checks it all
* Mon Mar 14 2011 KS Braunsdorf ksb@npcguild.org 2.32
- This is a good update, you need this one.
- -j --/file works correctly now in hxmd, msrc and efmd, previously needed -I --
- hxmd invar. for %u == HXMD_U broke when m4exit(NON_ZERO) aborted a host
- some documentation fixes (nbsp's, spelling, content, anchors, and tidy)
- html fixes for style (viz. class="spelling error") and punctuation fixes
- fixed a long-standing bug with failed m4 processes in hxmd decrementing -P
- platform recipes missing SOURCE elements (mmsrc, hxmd)
* Fri Nov 26 2010 KS Braunsdorf ksb@npcguild.org 2.31
- fixed from bracket errors
- added some missing quotes
* Tue Nov 12 2010 Thomas Swan 2.3
- extra cleanup
* Sat Aug 14 2010 KS Braunsdorf 2.29
- mmsrc's default -m was wrong (__mmsrc != __msrc)
- options.html was missing -m prereq[:postreq]
* Fri Aug 13 2010 KS Braunsdorf 2.28
- mkcmd manual page fix to bind option to its argument
- more examples in ptbw manual page
- hxmd had missing files in recipes, updated README+TODO
-  added cache directory support, which is way cool (via dir/Cache.m4)
-  failure to init the hostdb now gets sent back to the main for cleanup
-  support the HXMD_PHASE macro for -j files to know which m4 included them
-  the -N action was mistakenly run when hostdb failed to init, fixed
-  lots of HTML and manpage updates
-  some reports of signal issues with the wait loops, not sure I fixed that
-  slot.m could add make's command echo output to caches (now spec -s always)
-  added the posse script (and example in the HTML docs)
- msrc added "dmz.man"
-  dmz.sh got the -S option to push be service (as an example in HTML docs)
-  added a second specification to -m to force a cleanup update after a push
-  allow the token "+++" to specify that a macro list accepts more files/dirs
-  allow the token "." to specify that a macro list is as full as is can be
-  dirs can be added to MAP if they end in .host (as a cache dir for hxmd)
-  added regression tests for new features
-  upgrades to the HTML documents, but references to flock/oue dangle
- mmsrc got all the fixes from hxmd and msrc
-  the phases for mmsrc are close to hxmd, but not exactly the same viz. "cmd"
* Sun Dec 06 2009 KS Braunsdorf 2.17
- mkcmd got a new hook only I care about (%m to defer meta code), NULL checks
- explode more version information in some modules
- hxmd does cache directories, so you don't have to use m4 for everything
-  added -j every.m4 to allow a markup package to include globally
-  (et al) a command-line explict "./file" now defeates the -I search code
-  hostdb.m, the macro "%" explans in the header markup to -k's spec
-  hostdb.m fixed some trailing value cases under -Z
- mmsrc spelling error in the include of stdlib.h
-  msrc/mmsrc/efmd fixes to add the above to these
- ptbw/xclate a kill -STOP bug-fix
- xapply changed expander bindings for -N expansion to something useful
-  added Dicer version to -V, fixed ptbw slot count
-  some lint in printf of host specific types "%ld" matched to (long) casts
* Sat May 09 2009 KS Braunsdorf 2.15
- upgraded hostdb.m to allow for -o "MACRO:OTHER"
- update html/man pages
- bug fix in mmsrc for -V/-h leaving a temp directory
- moved hxmd.1 to hxmd.8 where I thought it was
- fixed a quoting botch in "gnumake.m4"
- set the default HOSTOS to 00
* Tue Nov 18 2008 KS Braunsdorf
- allow HOSTOS to be a command-line define -- we should be able
  to compute it from /etc/redhat-release at least.
* Thu Nov 13 2008 KS Braunsdorf, Ed Anderson, and Thomas Swan
- Redid the RPM spec file, changed the name, tactics, and style a lot
* Fri Oct 17 2008 KS Braunsdorf <kevin.braunsdorf@fake.gmail.com>
- allow autoconfig to try if the default msrc build fails for mmsrc
  fix this change log
* Tue Jun 03 2008 Thomas Swan <thomas.swan@gmail.com> - 1
- Initial package
