# $Id: ITO.spec,v 1.18 2014/02/03 15:13:28 ksb Exp $
# $KeyFile: ${echo:-echo} manpage.cgi

%define _tmpdir			/tmp
%define _local_prefix		/usr/local
%define _local_bindir		%{_local_prefix}/cgi-bin
%define _local_mandir		%{_local_prefix}/man/man8

# for signing of packages
#%_signature gpg
#%_gpg_name FIXME@example.org

# %dist should be defined on the target but in case it isn't we can guess one
%define distguess %(cat /etc/{redhat,fedora,suse,ubuntu}-release | sed -e 's/Fedora Core/fc@/; s/Fedora/f@/; s/Red Hat[^0-9]*\(Enterprise|Server\)*[^0-9]*/rhel@/; s/Red Hat[^0-9]*/rh/; s/.*Suse[^0-9]*/se@/; s/Ubuntu[^0-9]*/ubuntu@/; s/@[^0-9]*//;s/\([0-9][0-9]*\)[^0-9][^0-9]*\([0-9][0-9]*\)/\1_\2/; s/[^0-9]*$//')
%{!?dist:%define dist .%{distguess}}

# Do not generate debugging packages by default - older versions of rpmbuild
# (like RehHat 6.2) choke on the line with the percent in the macro name:
# We need a sed spell on RH6.x to "s/\(^.define \)%d/\1d/", Sigh. -- ksb
%define debug_package %{nil}

Name:		manpage.cgi
Version:	1.33
Release:	4%{?dist}
BuildRoot:	%{_tmpdir}/%{name}-%{version}-%{release}
Vendor:		NPCGuild.org
Summary:	NPC tool which converts manualpages to HTML for web display
Group:		Applications/web
License:	BSD
URL:            http://patch.sac.fedex.com/RPMS
Source:         http://carrera.databits.net/~ksb/dl/2013/%{name}-%{version}.tgz
BuildRequires:	gcc m4 msrc_base install_base
# Autoreq:0 prevents misleading depencies from being generated. Normally, this
# is perfectly sane; however, the system is picking up mk directives and
# mkcmd directives as well as system depencies.
Autoreq:	0
Requires:	/bin/ksh install_base perl

%description
Largely used to link ksb's HTML documents to the related manual pages.
Also has nifty id=section features.  Pages should follow manstyle(1).
See ckman for that manual page and some help checking manual pages.

%prep
%setup
%build
%install
umask 022
mkdir -p %{buildroot}/%{_local_bindir} %{buildroot}/%{_local_mandir}
F=`mktemp -d /var/tmp/bmHMXXXXXX`
mmsrc -y INTO=$F -Cauto.cf -- \
	make TOP=%{_local_prefix} DESTDIR=%{buildroot} install mkcat
rm -rf $F
find %{buildroot} -depth -type d -name OLD -exec rm -rf \{\} \;

%clean
# Do not conflict with the next user of the fixed-path build directory
[ / != "%{buildroot}" ] && rm -rf "%{buildroot}"

%files
%defattr(-,root,root)
%{_local_bindir}/%{name}
%doc %{_local_mandir}/

%changelog
* Sat Feb  1 2014 KS Braunsdorf msrc@ksb.npcguild.org 1.33.4
- remove calls to mkcat, stop installing the meta-manualpage
* Fri Jan 31 2014 KS Braunsdorf msrc@ksb.npcguild.org 1.33.2
- built the target dirs in build, should be in install
* Tue Dec 24 2013 KS Braunsdorf msrc@ksb.npcguild.org 1.33
- allows more than 2 words in a .SH header.  Added a TODO for contractions.
* Fri Dec 13 2013 KS Braunsdorf msrc@ksb.npcguild.org 1.32
- italic &, <, >, and bold < were busted.  Sorry.
* Tue Oct 29 2013 KS Braunsdorf msrc@ksb.npcguild.org 1.31.2
- updated manual page and HTML pages
* Thu Oct 17 2013 KS Braunsdorf msrc@ksb.npcguild.org 1.31
- fixed the RE that didn't match numbers in section headers (M4 ENVIRONMENT)
* Thu Sep 19 2013 KS Braunsdorf msrc@ksb.npcguild.org 1.30.2
- viceversally fixed the name of the RPM file to match the path
- installed the manual page
* Tue Jul 16 2013 KS Braunsdorf msrc@ksb.npcguild.org 1.30
- fixed literal urls to render as html links
- made options like -count build an id="count" internal anchor
* Wed Jul 10 2013 KS Braunsdorf msrc@ksb.npcguild.org 1.27
- while (defined($token = shift @s)) .ne.  while ($token = shift @s)
- updated TODO
* Tue Jul  9 2013 KS Braunsdorf msrc@ksb.npcguild.org 1.27
- updated the manual page and fixed some white-space checks.
* Mon Jul 08 2013 KS Braunsdorf msrc@ksb.npcguild.org 1.26
- Built the RPM spec file and added it to the msrc cache
