.\" $Id: manpage.cgi.man,v 1.14 2013/10/24 00:08:35 ksb Exp $
.\" by KS Braunsdorf
.\" $Compile: Display%h
.\" $Display: ${groff:-groff} -Tascii -man %f |${PAGER:-less}
.\" $Display(*): ${groff:-groff} -T%s -man %f
.\" $Install: %b -mDeinstall %o %f && cp %f $DESTDIR${TOP:-/usr/local}/man/man8/manpage.cgi.8
.\" $Deinstall: ${rm-rm} -f $DESTDIR${TOP:-/usr/local}/man/man8/manpage.cgi.8*
.TH MANPAGE.CGI 8 LOCAL
.SH NAME
manpage.cgi - render local manual pages as HTML
.SH SYNOPSIS
.ds PN "manpage.cgi
QUERY_STRING=\fIpage\fP \fI\*(PN\fP
.SH DESCRIPTION
This CGI (common gateway interface) renders any nroff formatted manual page
as HTML (HyperText Markup Language).  The rendering includes
hyper-links to other manual pages, good font markup, and internal
anchors for sections.  Pages render best when the follow \fBmanstyle\fP(1l).
.P
Internal \fB\&id\fP anchors mark each \fB\.SH\fP section, and the
definition of each option.  These allow hypertext links to
reference specific sections.  The options are tagged as
\fB\&opt_\fP\fIl\fP for lowercase letters \fIl\fP and
\fB\&opt_u\fP\fIL\fP for uppercase letters \fIL\fP.  Sections are
marked with the first word in the section name.
.P
Explicit URLs (Uniform Resource Locators) which use the "http",
"https" or "ftp" schema are rendered as anchors as well.
.SH OPTIONS
Being a CGI, this program only reads the environment variable
\fB\&QUERY_STRING\fP for the specification of the requested manual page.
.P
The \fB\&QUERY_STRING\fP consists of the manual page name, and an optional
section number.  If the number is suffixed with the letter \fBl\fP, then
a local manual page directory may be added to the page search path.
.P
The standard version option is replaced by an HTML comment which includes
the \fBrcs\fP(1) Revision keyword.  This is the first comment after
the start of the \fB\&body\fP markup.
.SH EXAMPLES
.TP
.nf
QUERY_STRING='quot&8' manpage.cgi | ${PAGER:-less}
.fi
Render the quot(8) manual page, from a shell.
.TP
.nf
<A href=\*(lq/cgi-bin/manpage.cgi?quot&amp;8\*(lq> quot(8) </A>
.fi
The above request as a HyperText link.
.TP
.nf
<A href=\*(lq/cgi-bin/manpage.cgi?quot&amp;8#ENVIRONMENT\*(lq> quot(8) </A>
.fi
The same output as above, but jump to the ENVIRONMENT section of the
page.
.TP
.nf
<A href=\*(lq/cgi-bin/manpage.cgi?manpage.cgi&amp;8#EXAMPLES\*(lq> manpage.cgi(8) </A>
.fi
A link to this page's EXAMPLES section.
.SH BUGS
HyperText links underline white-space when they wrap a line.  Avoid this by
forcing line-breaks above or below explicit links. I suggest \fB.TP\fP markup.
.SH AUTHOR
KS Braunsdorf
.br
NonPlayer Character Guild
.br
manpage swirl spam dot ksb dot npcguild.org remove spam dot.
.SH "SEE ALSO"
.hlm 0
manstyle(1l), ckman(8l), httpd(8)
