.\" $Id: makeme.man,v 4.19 2013/10/22 19:02:27 ksb Exp $
.\" $Compile: Display%h
.\" $Display: ${groff:-groff} -Tascii -man %f | ${PAGER:-less}
.\" $Display(*): ${groff:-groff} -T%s -man %f
.\" $Install: %b -mDeinstall %o %f && cp %f $DESTDIR${TOP:-/usr/local}/man/man8/makeme.8
.\" $Deinstall: ${rm-rm} -f $DESTDIR${TOP:-/usr/local}/man/[cm]a[nt]8/makeme.8*
.TH MAKEME 8 LOCAL "MBUILD(8)"
.SH NAME
makeme, mbuild - fake the master source build sequence for the local machine
.SH SYNOPSIS
.ds PN "makeme
.ds PA "mbuild
\fI\*(PN\fP [\fImmsrc-opts\fP] [\fImake-opts\fP] \fItargets\fP
.br
\fI\*(PN\fP \fB\-V\fP
.br
\fI\*(PA\fP [\fB\-arv\fP] [\fB\-C\fP\~\fIdb\fP] [\fB\-m\fP\~\fIpath\fP]
[\fIsite\fP] [\fIproducts\fP]
.br
\fI\*(PA\fP \fB\-h\fP
.br
\fI\*(PA\fP \fB\-V\fP
.SH DESCRIPTION
\fIMakeme\fP is the utility for boot-strapping ksb's master
source environment (version 1).
Often called from \fI\*(PA\fP to execute a package build.
.P
\fIMbuild\fP is the dependency manager for \fImakeme\fP, it tries to
download and build the master source tool suite in the correct order with
some help from the installer.
.SH OPTIONS
All options to \fImakeme\fP are passed to \fBmake\fP(1), unless the only parameter
on the command line is "\fB\-V\fP".  \fIMbuild\fP takes these options:
.TP
.nf
\fB\-a\fP
.fi
Auto-install a tool when it builds successfully.  When run as
the super-user this is a real time saver.  When run as a mortal
user the driver must type root's password for each tool.
In the default case \fI\*(PA\fP makes the driver \fBsu\fP(1)
and type "makeme install"
for every tool, which is a safety feature -- but tedious.
.TP
.nf
\fB\-C\fP \fIdb\fP
.fi
Specify the dependency database as \fIdb\fP.
Any existing local file is used in preference to a file from
the \fIsite\fP provided.
.TP
.nf
\fB\-m\fP \fItop\fP
.fi
Specify a top directory for the cached platform source code, some tools use
the source code from others as part of their source (for the build process).
The order declared in the \fIdb\fP file assures the correct build order,
but the code must be staged under \fItop\fP until all the tools
required are installed (then it may be deleted).
.TP
.nf
\fB\-r\fP
.fi
Remove any old source for each product as it is updated.
.TP
.nf
\fB\-v\fP
.fi
Be verbose when building the prerequisite dependency list.
This gives the driver some idea of what to build to reach the
tools they are after.
.TP
.nf
\fB\-V\fP
.fi
Output the standard version information.
.TP
.nf
\fIsite\fP
.fi
A URL in the form \fBfetch\fP(1) processes indicating the \fIsite\fP
where the gzip'd tar archives for each tool may be found (viz. \fBftp:\fP
or \fBhttp:\fP) or an \fBrsync:\fP style URL to force the use of \fBrsync\fP,
or a \fBfile:\fP URL to force the use of \fBcp\fP(1) for locally cached copies.
.SH EXAMPLES
.TP
.nf
\fI\*(PN\fP install
.fi
Commonly used to fake a push from a "master" to the local
machine, when no master is enabled.  This is how one builds
a local master, of course.  This will chain down to \fBmmsrc\fP
if the local directory looks like a \fBmsrc\fP source directory
rather than an older \fBdistrib\fP-based one.
.TP
.nf
\fI\*(PA \-v \-m /usr/msrc/local ftp://ftp.npcguild.org/pub/ksb
.fi
Walk the tool chain looking for things to install.  When all goes
well \fI\*(PA\fP drops you into an interactive shell in each
build directory.  Look around and install as you like (you might
have to \fBop\fP(1l), \fBsu\fP or \fBsudo\fP(1) to install each one).
.TP
.nf
\fI\*(PA \-va \-m /usr/msrc/local ftp://ftp.npcguild.org/pub/ksb sbp
.fi
Locate the \fBsbp\fP(8l) package from \fBnpcguild.org's\fP ftp service
and all the prerequisites needed to install it.  When run as
root this pretty quickly installs most products.
.TP
.nf
\fI\*(PA \-r \-m /usr/msrc/local ftp://ftp.npcguild.org/pub/ksb mkcmd
.fi
Upgrade mkcmd to the latest release.
.SH BUGS
Some packages (like \fBentomb\fP) require a login to be created.
There is no mechanism here to warn you, or take the necessary
\fBadduser\fP(8) actions (yet).  The FreeBSD ports/packages system
or RPM, or the like can be wrapped around these packages to
take such platform specific actions.
.P
This should know more about symbolic release names, and will.
.SH AUTHOR
KSB Braunsdorf, Non-Player Character's Guild,
.br
msrc no-spam-at ksb.npcguild.org
.SH "SEE ALSO"
.hlm 0
fetch(1), make(1), rsync(1), m4(1), mmsrc(8l), msrc(8l), efmd(8l),
distrib(8l), entomb(7)
