'\" te
.\" $Id: msrc.man,v 1.71 2013/12/15 19:05:31 ksb Exp $
.\" by KS Braunsdorf
.\" $Compile: Display%h
.\" $Display: ${groff:-groff} -Tascii -man %f | ${PAGER:-less}
.\" $Display(*): ${groff:-groff} -T%s -man %f
.\" $Install: %b -mDeinstall %o %f && cp %f $DESTDIR${TOP:-/usr/local}/man/man8/msrc.8
.\" $Deinstall: ${rm-rm} -f $DESTDIR${TOP:-/usr/local}/man/[cm]a[nt]8/msrc.8*
.TH MSRC 8 LOCAL
.SH NAME
msrc - master source remote command
.SH SYNOPSIS
.ds PN "msrc
.\" or make secure remote command
.\" or my ssh remote control --ksb
\fI\*(PN\fP [\fB\-lz\fP] [\fB\-\fP\fIpreload\fP] [\fB\-P\fP\fIjobs\fP] [\fB\-d\fP\~\fIflags\fP] [\fB\-m\fP\~\fIprereq\fP[\fB:\fP\fIpostreq\fP]] [\fB\-f\fP\~\fImakefile\fP] [\fB\-u\fP\~\fIlogin\fP] [\fB\-y\fP\~\fIyoke\fP] [\fIhxmd-options\fP] [\fIutility\fP]
.br
\fI\*(PN\fP \fB\-h\fP
.br
\fI\*(PN\fP \fB\-V\fP
.SH COMPLETE
\fI\*(PN\fP [\fB\-Algnsz\fP] [\fB\-\fP\fIpreload\fP] [\fB\-B\fP\~\fImacros\fP] [\fB\-C\fP\~\fIconfigs\fP] [\fB\-D\fP\~\fIname[=value]\fP] [\fB\-d\fP\~\fIflags\fP] [\fB\-E\fP\~\fIcompares\fP] [\fB\-f\fP\~\fImakefile\fP] [\fB\-G\fP\~\fIguard\fP] [\fB\-I\fP\~\fIdirname\fP] [\fB\-j\fP\~\fIm4prep\fP] [\fB\-k\fP\~\fIkey\fP] [\fB\-m\fP\~\fIprereq\fP[\fB:\fP\fIpostreq\fP]] [\fB\-o\fP\~\fIattributes\fP] [\fB\-P\fP\fIjobs\fP] [\fB\-R\fP\~\fIreq\fP] [\fB\-U\fP\~\fIname\fP] [\fB\-u\fP\~\fIlogin\fP] [\fB\-X\fP\~\fIex-configs\fP] [\fB\-y\fP\~\fIyoke\fP] [\fB\-Y\fP\~\fItop\fP] [\fB\-Z\fP\~\fIzero-config\fP] [\fIutility\fP]
.SH DESCRIPTION
Think of this as a network-aware addition to \fBmake\fP.
The goal is to run a recipe on every host in a (potentially long)
list of hosts.
To do that we are going to synchronize some files
from the current directory to a remote host, then run the
\fIutility\fP on that remote host, from the updated directory.
.P
This is really a front-end for \fBhxmd\fP which makes it less cumbersome to
call \fBrdist\fP(1), \fBmake\fP(1) and \fBssh\fP(1) to
update many target hosts.
This program completes the refactoring and replacement of \fBdistrib\fP(8l)
as the basis of "ksb's master source" software distribution and
installation system.
.P
To send the appropriate files to the target host \fI\*(PN\fP classifies
all the files in the current directory into a few classes:
.TP
.nf
Those that are sent as-is (\fB\&SEND\fP)
.fi
Each file is updated as an exact replica on every target host.
.TP
.nf
Those that are ignored (\fB\&IGNORE\fP)
.fi
None of these are updated on the target host.
.TP
.nf
Those that are macro processed for each target (\fB\&MAP\fP)
.fi
Each file is run through \fBm4\fP(1) with attribute macros defined
for each target host.  The resulting stream is sent to the target
host for additional processing.  If the node listed is a directory \fBhxmd\fP
uses the file \f(CBCache.m4\fP as a marked-up recipe file, which it
processes though \fBm4\fP, then uses to update the directory.  The output
from that command is sent to the target host.  See \fBhxmd\fP(8l).
.TP
.nf
Those that contain options to \fBhxmd\fP (\fB\&HXINCLUDE\fP)
.fi
These are used to tune parameters to the underlying \fBhxmd\fP
machinery.
.P
To do this \fI\*(PN\fP consults macro values from the \fImakefile\fP
specified.  It appends a generated target to a copy of that recipe file.
The generated target name is the basename of the program prefixed
with 2 underscores (\*(lq__\*(rq), so the default one would be
\*(lq__msrc\*(rq.
That double-underscore target outputs the value of 7 \fBmake\fP macros:
\fB\&INTO\fP, \fB\&MODE\fP, \fB\&SEND\fP, \fB\&MAP\fP, \fB\&SUBDIR\fP,
\fB\&IGNORE\fP, and \fB\&HXINCLUDE\fP.
When some of these are left empty \fI\*(PN\fP tries
to deduce the proper disposition of each filename.
This chicanery allows the author of the recipe file to
use any other target for the work at hand, and put explicit
dependencies in the recipe file for the generated target.
.P
Usually any explicit dependencies create payload files just before they are
transmitted to the target hosts.
.P
\fIMsrc\fP constructs two files from
the extracted \fBmake\fP macro definitions, the \fIutility\fP provided,
and the filenames in the current working directory.
All of this information is used to create an \fBhxmd\fP(8l) instance to
select the target hosts, update each, then execute \fIutility\fP on
each one.
.P
The first file constructed is an \fBrdist\fP \fIdistfile\fP, with
\fBm4\fP mark-up, to drive the data synchronization phase of
the update.
The second file is a shell script provided as the \fIcontrol\fP
parameter to \fBhxmd\fP.
It calls \fBrdist\fP \fB\-f\fP
on the \fBm4\fP processed \fIdistfile\fP to update the
remote target, then \fBssh\fP to obtain a shell on the remote
target, source any entry definitions file, and run the \fIutility\fP.
In each of these there are substantial \fBm4\fP hooks to refine
command-line parameters to effect each facility.
.P
Any \fBmake\fP macros explicitly specified in the \fImakefile\fP
are preferred to generated values constructed from
the list of files in the current directory.
Any macro given a non-empty value in the \fImakefile\fP will never be
adulterated by \fI\*(PN\fP, unless it contains the meta token "\fB+++\fP"
(three plus signs).
All macros left empty (or undefined) assume as many of the
remaining files as possible, based on the rules below.
.P
The \fB\&SEND\fP, \fB\&MAP\fP, and \fB\&SUBDIR\fP macros may contain one of
two meta tokens: \fB+++\fP specifically requests that unassigned files
be appended to that macro, or \fB.\fP to specifically requests that no
(addtional) files be assigned to that macro.  (Typically \fB\&MAP=.\fP would
avoid any macro replacement on every local file ending in \*(lq.host\*(rq.)
.P
The default \fIutility\fP, is given in the \fB\-V\fP output, by default
it is \fBmake\fP with no additional parameters.
That strongly implies that we send a \fBmake\fP(1) recipe file
called either "makefile" or "Makefile" to the target hosts.
.\" or that we really like the error message "make: no target to make."
.SH OPTIONS
Note that (while not listed) any option which might be passed to
\fBhxmd\fP is allowed in \fI\*(PN\fP's command-line.
We actually call \fBhxmd\fP with our program name forced as
\fB\&argv[0]\fP.
Since \fBhxmd\fP accepts a default zero configuration file via
the basename in \fB\&argv[0]\fP we are changing that default value.
We don't do this when we see an explicit \fB\-Z\fP passed on
our command-line.
.TP
.nf
\fB\-\fP\fIpreload\fP
.fi
The \fBhxmd\fP instance created to process the request generates all the
temporary files in advance of the process launch.  The integer sets the
number of tasks that are prepared for launch in addition to number of
parallel tasks (under \fB\-P\fP below).
.TP
.nf
\fB\-A\fP
.fi
Passed to \fBxapply\fP via \fBhxmd\fP to present \fBptbw\fP tokens
on the end of the parameter list.  This requires some detailed
knowledge of the command-line given to \fBxapply\fP, and it not for
the faint of heart.  To be truly useful an instance of \fBptbw\fP
must already be in-scope, or set via \fB\-t\fP.
.TP
.nf
\fB\-d\fP \fBP\fP
.fi
If any of \fIflags\fP contain the upper case letter 'P' (\fBP\fP for position)
\fI\*(PN\fP traces the modifications made to
the original \fImakefile\fP, as well as the disposition of each file in
the macro lists on \fIstderr\fP.
.TP
.nf
\fB\-d\fP \fBS\fP
.fi
If any debug option to \fBm4\fP (passed through \fBhxmd\fP) contains
the upper case letter 'S' (\fBS\fP for send scripts)
\fI\*(PN\fP outputs the two files
constructed for \fBhxmd\fP on \fIstderr\fP (as shell here-documents).
.TP
.nf
\fB\-d\fP \fBX\fP
.fi
The "trace execution" switch to \fBhxmd\fP also traces the command-line
given to \fBhxmd\fP, with the \fB\&argv\fP masking shown.
.TP
.nf
\fB\-f\fP \fImakefile\fP
.fi
Specify the \fBmake\fP(1) recipe file \fI\*(PN\fP studies to extract
any \fBmake\fP macro definitions.
We search for the files \f(CBMsrc.mk\fP and \f(CBmsrc.mk\fP before
\fBmake\fP's defaults of \f(CBmakefile\fP and \f(CBMakefile\fP.
This allows the local control logic to
be separated from the remote logic (or not).
.TP
.nf
\fB\-F\fP \fIliteral\fP
.fi
This option is forced by \fI\*(PN\fP when calling \fBhxmd\fP so
it may not be presented on the command-line.
.TP
.nf
\fB\-h\fP
.fi
Print a brief help message.
.TP
.nf
\fB\-l\fP
.fi
The environment built resides on the local filesystem, rather than
the remote host's, and the \fIutility\fP is run from that temporary
directory.  This allows the use of some other file synchronization
utility (rather than \fBrdist\fP) to update the remote host.
See "LOCAL MODE" below.
.TP
.nf
\fB\-m\fP \fIprereq\fP[\fB:\fP\fIpostreq\fP]
.fi
Specify the double-underbar target used to extract any macro values.
This is intended for scripts built on top of \fB\*(PN\fP, so
use the default \*(lq__msrc\*(rq for simple tasks.
.sp
The optional \fIpostreq\fP is updated with \fBmake\fP after
the complete build with the macro MSRC_EXITCODE defined as
the integer exit code from the \fBhxmd\fP update process.
In that case the cleanup process overlays the original \fB\*(PN\fP.
A trailing colon implies a \fIpostreq\fP of \*(lq__clean\*(rq.
.TP
.nf
\fB\-P\fP\fIjobs\fP
.fi
Specify the number of tasks to run in parallel, default 6.
See BUGS below.
.TP
.nf
\fB\-u\fP \fIlogin\fP
.fi
If \fIlogin\fP is not the empty string it specifies a default value
for the \fB\&ENTRY_LOGIN\fP \fBm4\fP macro attribute.
.TP
.nf
\fB\-V\fP
.fi
Show version information, and some tuning information.
.TP
.nf
\fB\-y\fP \fIyoke\fP
.fi
Each \fIyoke\fP specification
presents a command-line word to the invocation of \fBmake\fP
used to plunder the \fImakefile\fP, these tie-points allow
one \fBmake\fP recipe file to syzygy several subdirectories.
.\" syzygy to align multiple points (like planets)
For example to change the \fB\&INTO\fP macro in
each directory's control logic.  This option is most often set
in a \fB\&PRE_CMD\fP recursively call to \fI\*(PN\fP for each nested product.
.TP
.nf
\fB\-z\fP
.fi
This option removes all the files from the macro \fB\&HXINCLUDE\fP.
This saves editing effort when debugging or reusing code, but not
messing with any \fB$HXMD_PASS\fP environment already set.
.TP
.nf
\fB\-Z\fP \fIconfig\fP
.fi
Unless this option is presented the argument vector built for
\fBhxmd\fP indicates the name of the program is the same as
the name \fI\*(PN\fP was called.  The has two effects: first
error messages look like they come from "msrc" rather than "hxmd",
second this tells \fBhxmd\fP to look for a default zero
configuration file with our program name as the base.  Thus
any local configuration may be selected by default (and be
distinct from \fBhxmd\fP's defaults).
.\" Overriding the value with an explicit
.\" \fB\-Z\fP may break this program in strange and unlikely ways.
.SH "MACRO SELECTION"
This is a list of the \fBmake\fP(1) macros expected,
and how each is constructed or derived.
.TP
.nf
\fB\&INTO\fP
.fi
This is the name of our remote source cache on each target host.
A default value is available only when the current working directory
contains the string "/msrc/".
In that case the string `/msrc/' in that string is replaced with
`/src/' to form a default value.
Otherwise the \fImakefile\fP must set a single explicit value.
The explicit value dot (\fB.\fP) forces the target directory to
be the remote login's home directory.  This creates unexpected peril,
as it is very easy to delete all the files in that directory.
.TP
.nf
\fB\&MODE\fP
.fi
This allows the \fImakefile\fP to request local mode.
Otherwise the invoker must specify the command-line option \fB\-l\fP,
which they are apt to forget.  There explicit values are allowed:
"local", "remote" and "auto".  Local adds \fB\-l\fP to the
command-line, if not specified.  Remote forbids the use of \fB\-l\fP,
as well as the use of \fBmmsrc\fP(8l).  Auto allows either, and is the default
value when none is provided.
.P
All the macros below should consist of filenames from the current
directory, or possibly regular expressions (for \fB\&IGNORE\fP) which are
teated as literals in this phase.  Use an absolute or relative
path only with care.
.P
Next \fI\*(PN\fP assembles a list of all the local filenames which
do not already appear in any of the macros below (as given by the
\fImakefile\fP).
The code in \fI\*(PN\fP deduces the disposition of
each filename first eliminates any that already appear in a defined
macro, then includes any remaining filenames in exactly one
of these macros, which must have started off undefined (or empty):
.TP
.nf
\fB\&SUBDIR\fP
.fi
The is constructed from the list of directory nodes in
the current directory that are not any of "RCS", "SCCS", "CVS", or "SVN".
As always this macro is left as-is when it is provided in the \fImakefile\fP.
These directories are added to the generated distfile, see below.
.P
For any non-directory node we select the first macro not set
in the \fImakefile\fP which might accept each unmatched file.
Note that a macro accepts all unmatched files, accepting one doesn't
change the fact that the \fImakefile\fP didn't provide a value.
.TP
.nf
\fB\&MAP\fP
.fi
Any file or directory ending in ".host" is added to \fB\&MAP\fP macro, unless
that macro was given in the \fImakefile\fP (without the \fB+++\fP markup).
The ".host" suffix is removed on the remote host, and
the resulting name is added to \fB\&IGNORE\fP.
The name ".host" itself is left untouched to
avoid an empty filename on the remote host.
Any file mapped by this macro is run though \fBhxmd\fP's \fBm4\fP
expansion for the \fIfiles\fP parameter, the results thus generated
are the contents of the remote version.
.TP
.nf
\fB\&HXINCLUDE\fP
.fi
Any filename ending in ".hxmd" is added to \fB\&HXINCLUDE\fP macro, unless that
macro was given in the \fImakefile\fP.
This is a list files containing options to \fBhxmd\fP.
The special name dot (".") is ignored so that you can force
the macro to a fixed value that does not tamper with the environment.
A single file a with only a double-dash ("--") in
it forces the variable to be set to the empty string (which \fBhxmd\fP ignores).
Lines in each file beginning with an octothorp ("#") are ignored, and
newlines are converted to spaces.
.TP
.nf
\fB\&SEND\fP
.fi
Any other name is added to the \fB\&SEND\fP macro, unless that macro
was given in the \fImakefile\fP.
.TP
.nf
\fB\&IGNORE\fP
.fi
Any name not yet consumed is added to \fB\&IGNORE\fP, unless that
macro was given in the \fImakefile\fP.
.P
The source paths provisioned in \fB\&SEND\fP and \fB\&MAP\fP provide
data files for the processed files in the platform directory, but the
names of the files in the platform directory may be spelled
differently in the target.  There are two different ways to compress
the source path.
.P
Any source path which contains an explicit mention of the dot link in
its path (as "/./") has the leading elements up to that point removed
in the destination path.
The path "/usr/local/lib/other/./chase.c" when sent to "/tmp/lark"
results in the destination path "/tmp/lark/chase.c".
If this rule applies to a path the next rule cannot be applied.
This is copied from \fBrsync\fP's markup rules.
.P
Any source path that starts with a reference to the parent directory
(as "../") has that element removed in the destination path.
This rule is repeated until all leading dot-dot elements are removed.
To avoid this rule prefix the path with "././" and the previous rule
applied first.
This is based on the operational aspect of \fI\*(PN\fP
which says we are updating a target directory, not any sibling
directories.  This allows many subdirectories to share a common
file from the parent directory.
.SH "BUILD PHASE"
The \fIdistfile\fP construction builds 3 labeled file distribution
stanzas one for "myself", one for "dirs" and one for "files".
See EXAMPLES below for a spell to look at the constructed \fIdistfile\fP.
In outline it consists of a stanza to replicate the current directory,
the directories in \fB\&SUBDIR\fP (without descending into them)
then replicate the files from from \fB\&SEND\fP excepting
the patterns from \fB\&IGNORE\fP.  Then for each file in \fB\&MAP\fP
a separate stanza is constructed to copy the \fBm4\fP processed
file to the new name on the remote host.
.P
The \fIscript\fP construction builds a long \fBm4\fP file
with many \fB\&ifdef\fP hooks in it (see M4 HOOKS below) to help
fine-tune the actions.  The \fIutility\fP specified on the \fI\*(PN\fP
command-line is quoted to preserve the meaning as it is passed
through both \fBm4\fP and the \fBssh\fP shell command evaluation.
.SH "LOCAL MODE"
Under \fP\-l\fP we build a shell command to allocate a temporary
directory, fill it with the processed files from the local master,
change directory to that temporary work area, run \fIutility\fP, then
remove the work area.  This allows processing for nodes that are
unwilling or unable to accept \fBrdist\fP or \fBssh\fP connections.
This also allows meta-processes that should run in a context
that represents each target host, but need not be resident on that host.
.P
Tactics to think about at this point:
.IP \(bu 4
use \fBrsync\fP to update a host from the cached sources
.IP \(bu 4
stash an archive (\fBtar\fP(1) comes to mind) of
the processed files away for the client to fetch later
.IP \(bu 4
run a report function for the host, pulling data
back to the local machine
.IP \(bu 4
create a nested instance of \fI\*(PN\fP to process the source
again for clients related to the target host
.P
The ephemeral work areas are selected from a pool we construct under
$TMPDIR, via a \fBptbw\fP we install in the process tree (using
\fB\-d\fP as not to violate any use of that wrapper the client might
need).  The same \fBm4\fP hooks are presented to the local process,
which is always run with \fIstdin\fP redirected from \f(CB/dev/null\fP.
.P
The \fBptbw\fP instance is omitted by \fI\*(PN\fP,
as an optimization, under \fB\-P1\fP since only one directory may
be active at a time.
.SH "HXMD INTERFACE"
The catenated text of the files in \fB\&HXINCLUDE\fP
sets the variable \fB$HXMD_PASS\fP in
the environment of the new \fBhxmd\fP instance.
This is used to pass options down to the \fBm4\fP file processing,
or configuration file parts of \fBhxmd\fP while preserving any
use of \fB$HXMD\fP (under \fB\-l\fP).
.P
For compatibility with \fBmmsrc\fP, please only use the set of
options common to both \fBmmsrc\fP and \fBhxmd\fP, with
the addition of \fB\-z\fP to prevent \fB$HXMD_PASS\fP from lingering
in the environment.  Options to enclosed \fBxclate\fP instances,
like \fB\-T\fP, won't work when using \fBmmsrc\fP to boot-strap.
.P
The command-line passed to \fBhxmd\fP process always includes a
specific \fB\-P\fP, any \fB\-d\fP flags,
an explicit \fB\-F0\fP, the per-host update
script, the MAP files and the provision script.  The process may be wrapped
in an instance of \fBptbw\fP \fB\-d\fP or not, but in either case the
detached instance environment variable is preserved (viz. \fB$ptbw_d\fP).
.SH "M4 HOOKS"
Since \fBhxmd\fP makes extensive use of \fBm4\fP(1)
.\" to say the least
we provide many \fBm4\fP macro definitions as hooks that
your \fIconfig\fP (given under \fB\-C\fP, \fB\-X\fP or \fB\-Z\fP) might
specify to extend or change the behavior of the processing.
These may also be specified a \fB\-D\fP parameters to \fBm4\fP on
the command-line, or included in a \fIm4prep\fP file under \fB\-j\fP.
.TP
.nf
\fB\&SSH\fP
.fi
The name of the secure shell to use for remote target, defaults to "ssh".
.TP
.nf
\fB\&RSH_CMD\fP
.fi
A shell word that represents the command \fBrdist\fP should use
as a path to the remote shell program.  Be aware the \fBrdist\fP
doesn't like spaces in this value.  It is presented to
\fB\&SDIST\fP below with a "-P" prefix.  Defaults to "\fB\&SSH\fP"
or some other local value.
(This is \fBdistrib\fP compatible.)
.TP
.nf
\fB\&RDIST_PATH\fP
.fi
The path to \fBrdist\fP (or a work-alike) on the local host,
otherwise "rdist"
(This is \fBdistrib\fP compatible.)
.TP
.nf
\fB\&RDISTD_PATH\fP
.fi
The path to \fBrdistd\fP(8) on the remote host presented to
\fB\&SDIST\fP below prefixed with "-p", otherwise not used.
(This is \fBdistrib\fP compatible.)
.TP
.nf
\fB\&SDIST\fP
.fi
The combination of RDIST_PATH, RSH_COMMAND, RDISTD_PATH and the
command-line option to introduce the constructed \fIdistfile\fP.
.TP
.nf
\fB\&ENTRY_DEFS\fP
.fi
A filename to source (via the \fI.\fP command) to set shell variable
definitions in the remote shell, like \fB$PATH\fP or \fB$TZ\fP.
The default value should be set by the zero configuration file as
local site policy allows.  The default is none, but might be
set to "/usr/local/lib/distrib/local.defs" if you previously
used \*(lqsmsrc\*(rq or \fBdmz\fP(8l), which are example scripts I use.
.\" which I bet you didn't
.TP
.nf
\fB\&ENTRY_LOGIN
.fi
Our remote login name.  With this defined we add \fB\&ENTRY_LOGIN\fP\fB@\fP
as a prefix on the \fB\&HOST\fP macro \fBhxmd\fP defines for us.
.TP
.nf
\fB\&INCLUDE_CMD\fP(\fImode\fP)
.fi
Placed after the loader line, only when defined, this hook provides a way to
introduce \fBm4\fP \fB\&include\fP markup at the top of the file.
The macro parameter (\fI$1\fP) is either the word "local" or the word "remote".
.TP
.nf
\fB\&INIT_CMD\fP
.fi
Placed before we update the target directory, only when defined.
This provides a hook to debug the shell code, for
example via \*(lq \fB\-D INIT_CMD=\fP'set \-x' \*(rq.
.TP
.nf
\fB\&PRE_CMD\fP
.fi
Placed just before the invocation of \fIutility\fP and
after the construction of the working directory, only when defined.
For example this command might recurse into some
subdirectories to prepare them for the update of the current
directory.  If this invokes a shell \fB\&exit\fP, then we never
run \fIutility\fP, which might be exactly what you wanted.
.TP
.nf
\fB\&POST_CMD\fP
.fi
Placed after the \fIutility\fP to run some cleanup action on the
localhost, when defined.
Almost never defined in practice.  This might be used
to force \fBhxmd\fP to see a specific exit code, for retry logic.
.TP
.nf
\fB\&MSRC_MODE\fP
.fi
This is defined on the \fBhxmd\fP command-line as either "local" or
"remote".  It would be poor form to provide any other definition.
.P
In the context of the three "_CMD" macros above 5 shell parameters
are available to transmit our details to recursive calls to \fI\*(PN\fP:
.TP
.nf
\fI${1}\fP -- where
.fi
Under \fB\-l\fP this is the local cache directory, otherwise ".".
.TP
.nf
\fI${2}\fP -- which
.fi
The make recipe file used to process this directory.
.TP
.nf
\fI${3}\fP -- how
.fi
The mode ("local" or "remote") specified, "auto" is always replaced
with the selected mode.
.TP
.nf
\fI${4}\fP -- who
.fi
The credentials suggested to access the target host, either as
\fIlogin@host\fP or \fIhost\fP.  In local mode the string "localhost"
is suggested, which doesn't really imply that a local \fBssh\fP login is
required.
.TP
.nf
\fI${5}\fP -- why
.fi
The value of INTO, either from the \fImakefile\fP, a \fIyoke\fP, or from
the default rule.  This is the directory we need to update eventually
(under \fB\-l\fP for example).
.TP
.nf
\fI${6}...\fP -- \fBptbw\fP tokens under \fB\-R\fP
.fi
The value of the tokens recovered by \fBxapply\fP under \fB-R\fP.
.P
Note that the spelling of these parameters is important as
\fBm4\fP consumes similar names as parameters to its macros.
Viz. when they are spelled without the curly braces they are
usually replaced by \fBm4\fP with the empty string.
.P
Under local mode (\fB\-l\fP) these same parameters are available
to the \fIutility\fP itself.  In remote mode they are presently
not available.
.SH "DIVERSION HOOKS"
Rather than using the three "_CMD" macros one may use \fBm4\fP
\fB\&divert\fP markup to include preparatory code above, or
actions in the remote update script.  Diversion \fB0\fP usually includes
shell function definitions.
Diversion \fB2\fP inserts code after the positional parameters are
set.  Diversion \fB4\fP inserts code before \fB\&INIT_CMD\fP.
Diversion \fB6\fP inserts code before the \fB\&PRE_CMD\fP.
Diversion \fB8\fP inserts code before the \fB\&POST_CMD\fP.
.P
The common convention for the above is to use the \fB\&INCLUDE_CMD\fP macro to
\fB\&include\fP a file with diverted shell commands.  Anther way to use
this is to include a macro definition of \fB\&INCLUDE_CMD\fP in
a file under \fB\-j\fP, which should be ignored by any other markup.
For additional clues see the output from \fB\-d S\fP.
.SH CLUES
Get rid of the distracting noise from \fBrdist\fP with
a shell redirection in \fB\&RDIST_PATH\fP: unlike
the \fB\-p\fP and \fB\-P\fP options to \fBrdist\fP the mark-up
we use allows the redirection.  Just use a configuration line like:
.RS
.nf
RDIST_PATH=`rdist \-q >/dev/null'
.fi
.RE
to squelch the normal \fBrdist\fP output, but not the errors.  The
real clue here is that a shell redirection can appear within the
parameter list, which some folks never remember.
.P
Since \fBhxmd\fP is documented to run all the \fBm4\fP processing in
sequence (one slot at a time, left to right) it is safe to
depend on this behavior in \fI\*(PN\fP.
But this is only true if you define \fB\&MAP\fP yourself, if
\fI\*(PN\fP defines \fB\&MAP\fP it may select a different
order for the files (left to right) than you'd expect.
.P
In the remote case the \fIdistfile\fP is always placed after any
\fB\&MAP\fP files, and the \fIscript\fP is always before them.
Under \fB\-l\fP the code to select the ephemeral directory is always
first, the code to update that local directory is always last.
.SH EXAMPLES
.TP
.nf
\fI\*(PN\fP \-V
.fi
Display the standard version information and the default control command.
.TP
.nf
\fI\*(PN\fP \-C/dev/null \fB\-d S\fP true 2>&1 |less
.fi
Look at the constructed \fIdistfile\fP, and control \fIscript\fP for
the current directory (but don't update any hosts).
.TP
.nf
\fI\*(PN\fP \-C/dev/null \fB\-l\fP \-d S true 2>&1 |less
.fi
Look at the constructed control for a local update of this directory.
.TP
.nf
\fI\*(PN\fP \-C/dev/null \-d P true 2>&1 |less
.fi
Look at the constructed double-underscore makefile target, and
\fBmake\fP macros for the current directory, as extracted or
derived.
.TP
.nf
\fI\*(PN\fP \-B HASSRC \-C dmz.cf \-\- make all
.fi
Update all hosts from \fBdmz.cf\fP with the macro \fB\&HASSRC\fP defined.
This is very much like what \fBdistrib\fP did under \fB\-S\fP.
.TP
.nf
cd final && \fI\*(PN\fP \-ly INTO=/tmp/space/final \-B \fI...\fP make source
.fi
Suggest a value of \fB\&INTO\fP for the directory \f(CBfinal\fP that
places the platform source under our \f(CB/tmp/space\fP directory.
The source is positioned in an ephemeral platform directory, then
the "make source" recipe must copy it into "/tmp/space/final".
For a more direct route use \fBmmsrc\fP as:
.sp
.nf
cd final && \fBmmsrc\fP \-y INTO=/tmp/space/final \-B \fI...\fP :
.fi
.sp
which builds the platform source directly at \fB\&INTO\fP.
.TP
.nf
\fI\*(PN\fP \-d SPX \-d fl \fI...\fP
.fi
Since \fBhxmd\fP only passes the last \fB\-d\fP down to \fBm4\fP the
second option clears the unknown flags (which prevents \fBm4\fP from
carping on Solaris hosts).
.TP
.nf
# $Install(*): \fI\*(PN\fP %s \-DENTRY_LOGIN=bob  op make %M
.fi
Apply \fBmk\fP(1l) to update each host as "bob" (the builder) then
use \fBop\fP(1l) to escalate privileges to install the results.
This is very similar to the common control line in each
\fBdistrib\fP-based master source \f(CBMakefile\fP.
.TP
.nf
\fI\*(PN\fP \-C myhost.cl
.fi
This is the simplest example I could build:
given a list of hosts in the file \f(CBmyhost.cl\fP:
.nf
	SSH=\*(lq/usr/bin/ssh\*(lq # local absolute path to ssh(1)
	localhost
.fi
and a recipe in \*(CBMakefile\fP:
.nf
	INTO=/tmp/my$${USER:-$$LOGNAME}
	all:
		date; pwd; uname \-n
.fi
we output the date, current working directory, and hostname
(note the double-dollars so \fBmake\fP passes a dollar to the shell).
.TP
.nf
\fI\*(PN\fP \-l \-C myhost.cl
.fi
The same as above, but us a local ephemeral working directory,
rather than the defined \fB\&INTO\fP.
.TP
.nf
\fI\*(PN\fP \-zP10 \-C all.cf \-C test.cf \-B2 ./regression \e*.data
.fi
Use \fBhxmd\fP to intersect \fBall.cf\fP and \fBtest.cf\fP, run
the \f(CBregression\fP program on each host against \fI*.data\fP.
Take those hosts 10 wide.  Ignore the \fB\&HXINCLUDE\fP in the local
make recipe.
.TP
.nf
\fI\*(PN\fP \-zP10 \-C all.cf:test.cf \-m :purge \-B2 ./regression \e*.data
.fi
Almost the same as above, but trigger a \fBpurge\fP(8l) target in the
control recipe file after the show is over.
.TP
.nf
\fI\*(PN\fP \-lR2 \-t\fItokens\fP \-Gsulaco \-DPRE_CMD='echo ${6},${7}' \fI...\fP
.fi
Output the pair of \fIptbw\fP tokens bound to this update from
the \fItokens\fP file, before we run any update for \*(lqsulaco\*(rq.
Usually the \fBecho\fP(1) is replaced by a script which does
some task-related work.
.SH BUGS
The use of the \fBmake\fP target "__msrc" while plundering the
\fImakefile\fP is presumptuous. This is also a feature, as the
\fImakefile\fP may force dependencies on that target to create
a powerful "preparation work" features.
.P
Because the shell won't duplicate a file descriptor greater than 9,
\fI\*(PN\fP depends on having at least 1 file-descriptor in the
range 3 to 9 available for plundering the \fImakefile\fP.
.P
We do \fB\&not\fP guarantee that we call \fImake\fP exactly once.
Depending on the availability of low numbered file descriptors
in the \fI\*(PN\fP processes environment we may execute multiple
instances of \fBmake\fP, and therefore any dependent checks.
.P
It is also a fine-line feature that renaming \fI\*(PN\fP
is the only way to change the default zero-configuration file.
.P
Maybe the positional parameters should be available to remote mode.
This would require much more quoting in the remote execution phase.
It also breaks due to \fBssh\fP's command trapping, which double
evaluates the quotes in the \fB\&SSH_ORIGINAL_COMMAND\fP string.
If you want them on the remote side, then send them yourself.
.P
We should really get the default for \fB\-P\fP from \fBptbw\fP.
That would make it all so well connected.
But you can do it with \fB\-P\fP given the output of:
.RS
.nf
ptbw \-V | sed \-n \-e 's/.*tokens: //p'
.fi
.RE
.P
Before \fBhxmd\fP is installed (and \fBxapply\fP, \fBxclate\fP, et cetera)
it is not possible to install this program with itself: you'll have to
use \fBmmsrc\fP (mini-msrc) to get the ball moving.  There is a README
in that program's source, and a web page, to help you.
.SH AUTHOR
KS Braunsdorf, NonPlayer Character Guild
.br
msrc swirl ksb notspamDot npcguild.org
.SH "SEE ALSO"
.hlm 0
sh(1), m4(1), rdist(1), make(1), rsync(1), rdist(1), ssh(1), hxmd(8l),
xapply(1l), xclate(1l), ptbw(1l), mmsrc(8l), efmd(8l), mk(1l)
